#include "LedControl.h"
#include <binary.h>

//pin A2 is connected to the DataIn 
//pin A1 is connected to the CLK 
//pin A0 is connected to LOAD 
LedControl lc=LedControl(A2,A1,A0,1);
  
int afrTens = 0;
int afrOnes = 0;
int afrTenths = 0;
int afrHundredths = 0;
int afr = 0;
int afrRaw = 0;
int previousRow = 4;
int row = 0;
int col = 0;

void setup() {

lc.shutdown(0,false);
lc.setIntensity(0,7);
lc.clearDisplay(0);
  
}

void loop() {
    
  //afrRaw = analogRead(A6);  
  afr = map(afrRaw,0,1024,1000,2000);
  
  afrTens =       afr / 1000;
  afrOnes =       afr / 100   %10;
  afrTenths =     afr / 10    %10;
  afrHundredths = afr         %10;
  
  afrDisplay();
  barGraph();  
  
  afrRaw++;
  if(afrRaw==1024) afrRaw=0;
  previousRow=row;
  //delay(100); //update rate

}

void afrDisplay() {

  clearDigits();
  lc.setDigit(0,3,afrTens,false);
  lc.setDigit(0,2,afrOnes,true);
  lc.setDigit(0,1,afrTenths,false);
  lc.setDigit(0,0,afrHundredths,false);

}

void barGraph() {
  
  if(afr<=1299) row = 4;
  else if(afr>=1300&&afr<1600) row = 5;
  else if(afr>=1600) row = 6;
  
  switch(afr) {
    
    case 1000 ... 1049:
    clearBar(row);
    lc.setRow(0,row,B10000000);
    break;
    
    case 1050 ... 1099:
    clearBar(row);
    lc.setRow(0,row,B01000000);
    break;
    
    case 1100 ... 1149:
    clearBar(row);
    lc.setRow(0,row,B00100000);
    break;
    
    case 1150 ... 1199:
    clearBar(row);
    lc.setRow(0,row,B00010000);
    break;
    
    case 1200 ... 1249:
    clearBar(row);
    lc.setRow(0,row,B00001000);
    break;
    
    case 1250 ... 1299:
    clearBar(row);
    lc.setRow(0,row,B00000100);
    break;
    
    case 1300 ... 1349:
    clearBar(row);
    lc.setRow(0,row,B10000000);
    break;
    
    case 1350 ... 1399:
    clearBar(row);
    lc.setRow(0,row,B01000000);
    break;
    
    case 1400 ... 1449:
    clearBar(row);
    lc.setRow(0,row,B00100000);
    break;
    
    case 1450 ... 1499:
    clearBar(row);
    lc.setRow(0,row,B00010000);
    break;
    
    case 1500 ... 1549:
    clearBar(row);
    lc.setRow(0,row,B00001000);
    break;
    
    case 1550 ... 1599:
    clearBar(row);
    lc.setRow(0,row,B00000100);
    break;
    
    case 1600 ... 1649:
    clearBar(row);
    lc.setRow(0,row,B10000000);
    break;
    
    case 1650 ... 1699:
    clearBar(row);
    lc.setRow(0,row,B01000000);
    break;
    
    case 1700 ... 1749:
    clearBar(row);
    lc.setRow(0,row,B00100000);
    break;
    
    case 1750 ... 1799:
    clearBar(row);
    lc.setRow(0,row,B00010000);
    break;
    
    case 1800 ... 1849:
    clearBar(row);
    lc.setRow(0,row,B00001000);
    break;
    
    case 1850 ... 1899:
    clearBar(row);
    lc.setRow(0,row,B00000100);
    break;
    
    case 1900 ... 1949:
    //clearBar(row);
    lc.setRow(0,row,B00000010);
    break;
    
    case 1950 ... 2000:
    clearBar(row);
    lc.setRow(0,row,B00000001);
    break;
  
  }

}

void clearBar(int row) {
  
  if(row!=previousRow) {
    
    for(int i=4;i<8;i++) lc.setRow(0, previousRow, B00000000);
  
  }

}

void clearDigits() {
  
  for(int row=0; row<4; row++) {
    
    lc.setRow(0, row, B00000000);
  
  }

}
